
'*******************************************************************************
'******************      7-seg LED      ********************
'*******************************************************************************

' : ATMEGA8A    "AVR"    
'  : BASCOM-AVR 2.0.7.1
' : sasha_1973

'*******************************************************************************
'-------------------------------------------------------------------------------
'---------------            ----------------
'-------------------------------------------------------------------------------
  $regfile = "m8def.dat" : $crystal = 8000000 : $hwstack = 40 : $swstack = 16 : $framesize = 32
'-------------------------------------------------------------------------------
'*******************************************************************************
'*****************                                       ***********************
'*****************           I2c         ***********************
'*****************         PCF8574x       ***********************
'*****************                                       ***********************
'*******************************************************************************
'-------------------------------------------------------------------------------
  Config Sda = Portc.4       '  
  Config Scl = Portc.5       '  
  Config I2cdelay = 1       '  i2c "10 - 100, 5 - 200, 2 - 500, 1 - 1" -         
  I2cinit           '  i2c
  Dim _i2c As Byte
'-------------------------------------------------------------------------------
'------------------------------------------------------------------
'|             |  PCF8574,PCF8574N, PCF8575 |  PCF8574A, PCF8574AP |
'|-------------|----------------------------|----------------------|
'|  A0  A1  A2 |       |        |     |    |
'|-------------|-------------|--------------|-----------|----------|
'|  0   0   0  |      &H40   |     &H41     |    &H70   |   &H71   |
'|  1   0   0  |      &H42   |     &H43     |    &H72   |   &H73   |
'|  0   1   0  |      &H44   |     &H45     |    &H74   |   &H75   |
'|  1   1   0  |      &H46   |     &H47     |    &H76   |   &H77   |
'|  0   0   1  |      &H48   |     &H49     |    &H78   |   &H79   |
'|  1   0   1  |      &H4A   |     &H4B     |    &H7A   |   &H7B   |
'|  0   1   1  |      &H4C   |     &H4D     |    &H7C   |   &H7D   |
'|  1   1   1  |      &H4E   |     &H4F     |    &H7E   |   &H7F   |
'------------------------------------------------------------------
'-------------------------------------------------------------------------------

  Const __pcf8574 = &H7E
  Const __pcf8574 = &H7F

  Const __pcf8574 = &H70
  Const __pcf8574 = &H71

  Const _set = &B11111111
  Const _reset = &B00000000

' ------------------------------------------------------------------------------

'   .
'   ,      .
'       ,   .
'    -    .     .

'-------------------------------------------------------------------------------
'-----------------             -------------------
'-------------------------------------------------------------------------------
_:       '  ,  
'-------------------------------------------------------------------------------

  Dim __1_ As Byte       ' ,     
  __1_ = 0       '  _ = 1 ,   ,  _ = 0 ,  A

  Dim __2_ As Byte       ' ,     
  __2_ = 0       '  _ = 1 ,  K ,  _ = 0 ,  A

'-------------------------------------

  Const __ = 8       ' ,       

  Const __ = 50       ' ,     "Waitms"
  Const __tcnt0_timer0 = 250       ' ,     TCNT0

'-------------------------------------------------------------------------------
  Dim  As Byte

  Dim _led As Byte       ' ,      (     )
  Dim _ As Word       '       
  Dim _ As Word       ' ,       _(n) = 1
  Dim _ As Byte       '   
  Dim _word_1 As Word       ' ,   
  Dim _word_2 As Word       ' ,   
  Dim __led As Byte       ' ,     
  Dim __led As Word       ' ,    
  Dim ___led As Word       ' ,      (     )
  Dim 1____led As Word       ' ,    
  Dim 2____led As Word       ' ,    
  Dim ___ As Word       ' ,        "_(n) = 1"
  Dim (__) As Byte       '    8- 
  Dim _(__) As Byte       '    8- 
  Dim _(__) As Byte       '      8- 
  Dim _(__) As Byte       '      8- 
  Dim _(__) As Byte       ' ,       __(n) = 1
  Dim __(__) As Byte       '        8- 

'-------------------------------------------------------------------------------
'----------------------           ------------------------
'-------------------------------------------------------------------------------

  Declare Sub _()
  Declare Sub _7seg_led()
  Declare Sub __timer0()

'-------------------------------------------------------------------------------
'-------------------------------------------------------------------------------
'------------         LED      -----------
'-------------------------------------------------------------------------------

   Config Timer0 = Timer , Prescale = 64 , Clear Timer = 0

'-------------------------------------------------------------------------------

'   ,        (  ),
'    "PRESCALE = 1024".
'     : f(  - 4) / 1024(  
' (  - 1 , 8 , 64 , 256 , 1024)) = 3906.25    ,
'     . ,      Datasheet
' ,  "TIMER0" ,   256,  3906,25 / 256 ~ 15,26   
'   Led  ( 8-      ~ 15,26 / 8 = "",
'  ).    ,  "Atmel"   ,
'    ,   .
' ,  ,    "TCNT0". Tcnt0 - 8- ( 0  255)   - (TIMER0).
'     .   ,   .

'-------------------------------------------------------------------------------
'          LED 
'-------------------------------------------------------------------------------

'  Tcnt0 = __tcnt0_timer0       '     ( = 250)

'--------------------------------------------------------------------------------

'   ,   "TIMER0"     "0",    .
'  : 4000000 / 1024 / (256-( Tcnt0)) =  3906,25 / 6 ~ 651
' "TIMER0"  ,  1000(ms) /  651 ~ 1,536 ms,
'       7-seg LED .

' .

',   :  ,   ,
' ,      "TIMER0",   ,
'.

' ,       .

'-------------------------------------------------------------------------------
'-----------         TIMER0     ----------
'-------------------------------------------------------------------------------

   On Timer0 __timer0       '       TIMER0


'-----------------------          -----------------------
'-------------------------------------------------------------------------------

  _word_1 = 0       ' ,   
  _word_2 = 50       ' ,   

  _ = 300       '      LED   "_(n) = 1"
  ___ = _ / 2       '      LED   "_(n) = 1"

'-------------------------------------------------------------------------------
'------------------------            ------------------------
'-------------------------------------------------------------------------------

    Enable Timer0   '       

    Enable Interrupts       '    

'-------------------------------------------------------------------------------
'*******************************************************************************
'-------------------------------------------------------------------------------
'--------------------------           ---------------------------
'-------------------------------------------------------------------------------

  Do : Nop          '   Do  Loop,   TIMER0,   LED 

'--------------------------

    Incr _word_1       ' ,   
    If _word_1 > 9999 Then _word_1 = 0       '    9999,  
    1____led = _word_1       '    1  ( 4 )

    Decr _word_2       '  
    2____led = _word_2       '    2  ( 4 )

    If _word_2 = 0 Then       '    0,  "stop",  
        __(5) = 1 : _(5) = 5       '  "S"
        __(6) = 1 : _(6) = 14       '  "t"
        __(7) = 1 : _(7) = 15       '  "o"
        __(8) = 1 : _(8) = 28       '  "P"

        _(5) = 1       '  5 
        _(6) = 1       '  6 
        _(7) = 1       '  7 
        _(8) = 1       '  8 

    End If


    Waitms __       ' ,     

'--------------------------
  Loop
 End
'-------------------------------------------------------------------------------
'*******************************************************************************
'*****************      TIMER0   ****************
'*****************            1,536 ms          ****************
'*******************************************************************************
'-------------------------------------------------------------------------------
  __timer0:
'-------------------------------------------------------------------------------
'   Stop Timer0
    Rcall _7seg_led
'   Start Timer0
'-------------------------------------------------------------------------------
'  TIMER0 = 1000/(4000000/1024/(256-250))=1000/(3906,25 / 6) = 1,536 ms
'-------------------------------------------------------------------------------

'    Tcnt0 = __tcnt0_timer0

'-------------------------------------------------------------------------------
  Return
'-------------------------------------------------------------------------------
'*******************************************************************************
'-------------------------------------------------------------------------------
'*******************************************************************************
'*****************      LED    ****************
'*******************************************************************************
'-------------------------------------------------------------------------------
  _7seg_led:
'-------------------------------------------------------------------------------
'----------   ,           ---------
'-------------------------------------------------------------------------------
      __led = 1____led       '

      ___led = __led
'-------------------------------------------------------------------------------
'------------------       ,  4  1   -----------------
'-------------------------------------------------------------------------------
      For _led = 4 To 1 Step -1       '       4 
          __led = ___led Mod 10
          (_led) = __led       '
          ___led = ___led / 10       '
      Next
'-------------------------------------------------------------------------------
'----------   ,           ---------
'-------------------------------------------------------------------------------
      __led = 2____led       '

      ___led = __led
'-------------------------------------------------------------------------------
'------------------       ,  8  5   -----------------
'-------------------------------------------------------------------------------
      For _led = 8 To 5 Step -1       '       4 
          __led = ___led Mod 10
          (_led) = __led       '
          ___led = ___led / 10       '
      Next
'-------------------------------------------------------------------------------
'----------------------         -----------------------
'-------------------------------------------------------------------------------
    If __1_ = 1 Then
        I2csend __pcf8574 , _set       '     
      Else
        I2csend __pcf8574 , _reset       '     
    End If

    If __2_ = 1 Then
        I2csend __pcf8574 , _set       '     
      Else
        I2csend __pcf8574 , _reset       '     
    End If
'-------------------------------------------------------------------------------
'----    ,         -----
'-------------------------------------------------------------------------------
    Incr _
'-------------------------------------------------------------------------------
'-----           7-seg LED    ------
'-------------------------------------------------------------------------------
    If _ > __ Then
        _ = 1
    End If
'------------------------------------------------------------------------------------
'     ,        
'------------------------------------------------------------------------------------
'-------------------------------------------------------------------------------
'----------------------------       --------------------------
'-------------------------------------------------------------------------------
    Incr _

    If _ > _ Then _ = 1
'-------------------------------------------------------------------------------
'------------------    ,       ------------------
'-------------------------------------------------------------------------------
    If _(_) = 1 And _ > ___ Or _(_) = 1 Then       '         > 200
        Select Case _
          Case 1 To 4
            If __1_ = 1 Then
                __led = Lookup(11 , _ok)       '     1 - 4 
              Else
                __led = Lookup(11 , _oa)       '     1 - 4 
            End If
          Case 5 To 8
            If __2_ = 1 Then
                __led = Lookup(11 , _ok)       '     5 - 8 
              Else
                __led = Lookup(11 , _oa)       '     5 - 8 
            End If
        End Select
      Else
'-------------------------------------------------------------------------------
'-----------------------        ---------------------
'-------------------------------------------------------------------------------
        If __(_) = 1 Then
            Select Case _
              Case 1 To 4
                If __1_ = 1 Then
                    __led = Lookup(_(_) , _ok)       '  _  1 - 4 
                  Else
                    __led = Lookup(_(_) , _oa)       '  _  1 - 4 
                End If
              Case 5 To 8
                If __2_ = 1 Then
                    __led = Lookup(_(_) , _ok)       '  _  5 - 8 
                  Else
                    __led = Lookup(_(_) , _oa)       '  _  5 - 8 
                End If
            End Select
          Else
'-------------------------------------------------------------------------------
'-------          ,     ------
'-------------------------------------------------------------------------------
            __led = (_)
              Select Case _
                Case 1 To 4
                  If __1_ = 1 Then
                      __led = Lookup(__led , _ok)       '     ,    1 - 4 
                    Else
                      __led = Lookup(__led , _oa)       '     ,    1 - 4 
                  End If
                Case 5 To 8
                  If __2_ = 1 Then
                      __led = Lookup(__led , _ok)       '     ,    5 - 8 
                    Else
                      __led = Lookup(__led , _oa)       '     ,    5 - 8 
                  End If
              End Select
        End If
'-------------------------------------------------------------------------------
'-------------    ,        -------------
'-------------------------------------------------------------------------------
      If _(_) = 1 Then
          __led = __led Xor &H80       '&H80  &B10000000     
      End If
    End If
'-------------------------------------------------------------------------------
'---------------------              ----------------------
'-------------------------------------------------------------------------------
    I2csend __pcf8574 , __led
'-------------------------------------------------------------------------------
'---------------         ----------------
'-------------------------------------------------------------------------------
    Select Case _
      Case 1 : If __1_ = 0 Then  = &B00000001 Else  = &B11111110
      Case 2 : If __1_ = 0 Then  = &B00000010 Else  = &B11111101
      Case 3 : If __1_ = 0 Then  = &B00000100 Else  = &B11111011
      Case 4 : If __1_ = 0 Then  = &B00001000 Else  = &B11110111
      Case 5 : If __2_ = 0 Then  = &B00010000 Else  = &B11101111
      Case 6 : If __2_ = 0 Then  = &B00100000 Else  = &B11011111
      Case 7 : If __2_ = 0 Then  = &B01000000 Else  = &B10111111
      Case 8 : If __2_ = 0 Then  = &B10000000 Else  = &B01111111
    End Select
'-------------------------------------------------------------------------------
'---------------------------     PCF8574   ---------------------------
'-------------------------------------------------------------------------------
    I2csend __pcf8574 ,        '      PCF8574 
'-------------------------------------------------------------------------------
  Return
'-------------------------------------------------------------------------------
'*******************************************************************************
'-------------------------------------------------------------------------------
'*******************************************************************************
'-------------------------------------------------------------------------------
  _ok:
'-------------------------------------------------------------------------------
'-------------------------------------------------------------------------------
'----------------------------        ---------------------------
'-------------------------------------------------------------------------------
'    Data &H3F , &H06 , &H5B , &H4F , &H66 , &H6D , &H7D , &H07 , &H7F , &H6F       '0, 1, 2, 3, 4, 5, 6, 7, 8, 9
'    Data &H40 , &H00 , &H63 , &H39 , &H78 , &H5C , &H38 , &H74 , &H5E , &H77       '"-", "", " ", "", "t", "o", "L", "h", "d", "A"
'    Data &H58 , &H31 , &H76 , &H79 , &H50 , &H71 , &H1C , &H73 , &H37 , &H80       '"c", "", "", "E", "r", "F", "U", "u", "P", "". "."
'    Data &H54       ', &H , &H , &H , &H , &H , &H , &H , &H , &H '"n", "", "", "", "", "", "", "", "", "". ""
'-------------------------------------------------------------------------------
'-------     ,  ,       ------
'-------------------------------------------------------------------------------
    Data &H3F       ' 0   "0"
    Data &H06       ' 1   "1"
    Data &H5B       ' 2   "2"
    Data &H4F       ' 3   "3"
    Data &H66       ' 4   "4"
    Data &H6D       ' 5   "5"
    Data &H7D       ' 6   "6"
    Data &H07       ' 7   "7"
    Data &H7F       ' 8   "8"
    Data &H6F       ' 9   "9"
    Data &H40       ' 10  "_"
    Data &H00       ' 11  " "
    Data &H63       ' 12  " "
    Data &H39       ' 13  ""
    Data &H78       ' 14  "t"
    Data &H5C       ' 15  "o"
    Data &H38       ' 16  "L"
    Data &H74       ' 17  "h"
    Data &H5E       ' 18  "d"
    Data &H77       ' 19  "A"
    Data &H58       ' 20  "c"
    Data &H31       ' 21  ""
    Data &H76       ' 22  "H"
    Data &H79       ' 23  "E"
    Data &H50       ' 24  "r"
    Data &H71       ' 25  "F"
    Data &H3E       ' 26  "U"
    Data &H1C       ' 27  "u"
    Data &H73       ' 28  "P"
    Data &H37       ' 29  ""
    Data &H80       ' 30  ""
    Data &H54       ' 31  "n"
'-------------------------------------------------------------------------------
  _oa:
'-------------------------------------------------------------------------------
'    Data &HC0 , &HF9 , &HA4 , &HB0 , &H99 , &H92 , &H82 , &HF8 , &H80 , &H90       '0,1,2,3,4,5,6,7,8,9
'    Data &HBF , &HFF , &H9C , &HC6 , &H87 , &HA3 , &HC7 , &H8B , &HA1 , &H88       '"-", "", " ", "", "t", "o", "L", "h", "d", "A"
'    Data &HA7 , &HCE , &H89 , &H86 , &HAF , &H8E , &HC1 , &HE3 , &H8C , &HC8       '"c", "", "", "E", "r", "F", "U", "u", "P", ""
'    Data &H7F , &HAB       ', &H , &H , &H , &H , &H , &H , &H , &H , &H ' "." , "n", "", "", "", "", "", "", "", "", "". ""
'-------------------------------------------------------------------------------
'-------------------------------------------------------------------------------
'-------     ,  ,       ------
'-------------------------------------------------------------------------------
    Data &HC0       ' 0   "0"
    Data &HF9       ' 1   "1"
    Data &HA4       ' 2   "2"
    Data &HB0       ' 3   "3"
    Data &H99       ' 4   "4"
    Data &H92       ' 5   "5"
    Data &H82       ' 6   "6"
    Data &HF8       ' 7   "7"
    Data &H80       ' 8   "8"
    Data &H90       ' 9   "9"
    Data &HBF       ' 10  "_"
    Data &HFF       ' 11  " "
    Data &H9C       ' 12  " "
    Data &HC6       ' 13  ""
    Data &H87       ' 14  "t"
    Data &HA3       ' 15  "o"
    Data &HC7       ' 16  "L"
    Data &H8B       ' 17  "h"
    Data &HA1       ' 18  "d"
    Data &H88       ' 19  "A"
    Data &HA7       ' 20  "c"
    Data &HCE       ' 21  ""
    Data &H89       ' 22  "H"
    Data &H86       ' 23  "E"
    Data &HAF       ' 24  "r"
    Data &H8E       ' 25  "F"
    Data &HC1       ' 26  "U"
    Data &HE3       ' 27  "u"
    Data &H8C       ' 28  "P"
    Data &HC8       ' 29  ""
    Data &H7F       ' 30  ""
    Data &HAB       ' 31  "n"
'-------------------------------------------------------------------------------
'*******************************************************************************
'-------------------------------------------------------------------------------